.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    \masm32\include\user32.inc
INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\user32.lib

.CONST

WM_MOUSEHOOK EQU WM_USER+6

.DATA

hInstance DD 0

.DATA?

hHook DD ?
hWnd  DD ?

.CODE

DllEntry PROC hInst:HINSTANCE,  reason:DWORD,  reserved1:DWORD

    push hInst
    pop  hInstance
    mov  eax, TRUE
    ret

DllEntry ENDP

MouseProc PROC nCode:DWORD, wParam:DWORD, lParam:DWORD

    INVOKE CallNextHookEx, hHook, nCode, wParam, lParam
    mov    edx, lParam

ASSUME edx:PTR MOUSEHOOKSTRUCT

    INVOKE WindowFromPoint, [edx].pt.x, [edx].pt.y
    INVOKE PostMessage, hWnd, WM_MOUSEHOOK, eax, 0

ASSUME edx:NOTHING

    xor eax, eax
    ret

MouseProc ENDP

InstallHook PROC hwnd:DWORD

    push   hwnd
    pop    hWnd
    INVOKE SetWindowsHookEx, WH_MOUSE, ADDR MouseProc, hInstance, NULL
    mov    hHook, eax
    ret 

InstallHook ENDP

UninstallHook PROC

    INVOKE UnhookWindowsHookEx, hHook
    ret

UninstallHook ENDP

END DllEntry
