.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    HookDLL.inc
INCLUDELIB HookDLL.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

DlgFunc PROTO :DWORD, :DWORD, :DWORD, :DWORD

.CONST

IDD_MAINDLG   EQU 101
IDC_CLASSNAME EQU 1000
IDC_HANDLE    EQU 1001
IDC_WNDPROC   EQU 1002
IDC_HOOK      EQU 1004
IDC_EXIT      EQU 1005
WM_MOUSEHOOK  EQU WM_USER+6

.DATA

HookFlag   DD FALSE
HookText   DB "&Zaczep", 0
UnhookText DB "&Odczep", 0
template   DB "%lx", 0

.DATA?

hInstance DD ?
hHook     DD ?

.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE DialogBoxParam, hInstance,\
                           IDD_MAINDLG, NULL, ADDR DlgFunc, NULL
    INVOKE ExitProcess, NULL

DlgFunc PROC hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

LOCAL hLib:         DWORD
LOCAL buffer[128]:  BYTE
LOCAL buffer1[128]: BYTE
LOCAL rect:         RECT

    .IF uMsg==WM_CLOSE
        .IF HookFlag==TRUE
            INVOKE UninstallHook
        .ENDIF
        INVOKE EndDialog, hDlg, NULL
    .ELSEIF uMsg==WM_INITDIALOG
        INVOKE GetWindowRect, hDlg, ADDR rect
        INVOKE SetWindowPos, hDlg, HWND_TOPMOST,\
                             rect.left, rect.top,\
                             rect.right, rect.bottom, SWP_SHOWWINDOW
    .ELSEIF uMsg==WM_MOUSEHOOK
        INVOKE GetDlgItemText, hDlg, IDC_HANDLE, ADDR buffer1, 128
        INVOKE wsprintf, ADDR buffer, ADDR template, wParam
        INVOKE lstrcmpi, ADDR buffer, ADDR buffer1
        .IF eax!=0
            INVOKE SetDlgItemText, hDlg, IDC_HANDLE, ADDR buffer
        .ENDIF
        INVOKE GetDlgItemText, hDlg, IDC_CLASSNAME, ADDR buffer1, 128
        INVOKE GetClassName, wParam, ADDR buffer, 128
        INVOKE lstrcmpi, ADDR buffer, ADDR buffer1
        .IF eax!=0
            INVOKE SetDlgItemText, hDlg, IDC_CLASSNAME, ADDR buffer
        .ENDIF
        INVOKE GetDlgItemText, hDlg, IDC_WNDPROC, ADDR buffer1, 128
        INVOKE GetClassLong, wParam, GCL_WNDPROC
        INVOKE wsprintf, ADDR buffer, ADDR template, eax
        INVOKE lstrcmpi, ADDR buffer, ADDR buffer1
        .IF eax!=0
            INVOKE SetDlgItemText, hDlg, IDC_WNDPROC, ADDR buffer
        .ENDIF
    .ELSEIF uMsg==WM_COMMAND
        .IF lParam!=0
            mov ax, WORD PTR wParam
            mov dx, WORD PTR wParam + 2
            .IF dx==BN_CLICKED
                .IF ax==IDC_EXIT
                    INVOKE SendMessage, hDlg, WM_CLOSE, 0, 0
                .ELSE
                    .IF HookFlag==FALSE
                        INVOKE InstallHook, hDlg
                        .IF eax!=NULL
                            mov    HookFlag, TRUE
                            INVOKE SetDlgItemText, hDlg, IDC_HOOK,\
                                                   ADDR UnhookText
                        .ENDIF
                    .ELSE
                        INVOKE UninstallHook
                        INVOKE SetDlgItemText, hDlg, IDC_HOOK,\
                                               ADDR HookText
                        mov    HookFlag, FALSE
                        INVOKE SetDlgItemText, hDlg, IDC_CLASSNAME, NULL
                        INVOKE SetDlgItemText, hDlg, IDC_HANDLE, NULL
                        INVOKE SetDlgItemText, hDlg, IDC_WNDPROC, NULL
                    .ENDIF
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSE
        mov eax, FALSE
        ret
    .ENDIF
    mov eax, TRUE
    ret

DlgFunc ENDP

END start
